<template lang="pug">
  v-card(max-width='344' min-width="300" :color="confirm ? '#e2e2e2' : ''")
    v-card-text
      div {{number}}
      p.display-1.text--primary
        | {{name}}
      p {{type}}
      .text--primary
        | Поставщик: {{provider.name}}
        br
        | Дата создания: {{dateCreated}}
        br
        | Дата редактирования: {{dateEdit}}
    v-card-actions
      v-dialog(transition='dialog-bottom-transition')
        template(v-slot:activator='{ on, attrs }')
          v-btn(text='' color='teal accent-4' @click='reveal = true' v-on='on')
            | Подробнее
        template(v-slot:default='dialog')
          v-card
            v-toolbar(color='primary' dark='') {{number}} - {{name}}
            v-card-text
              p Поставщик:
              | ID: {{provider.id}}
              br
              | Addr: {{provider.addr}}
              br
              | ИНН: {{provider.inn}}
              p Товары
              ul
                li(v-for="item in items")
                  | Название "{{item.name}}",
                  | Цена {{item.price}},
                  | Кол-во {{item.count}},
                  | Сумма {{item.sum}}
              ul(v-if="extFields && Object.keys(extFields).length > 0") Дополнительные поля
                li(v-for="field in extFields")
                  | {{field}} : {{extFields[field]}}
            v-card-actions.justify-end
              v-row(v-if="!confirm")
                v-col(cols="4")
                  v-select(v-model="to" :items="users" item-value="id" item-text="name")
                v-col(cols="3")
                  v-btn(@click="SendTo") Отправить на подпись
                v-col(cols="3")
                  v-btn(@click="Confirm") Подписать
              v-btn(text='' @click='dialog.value = false') Закрыть
</template>


<script>
export default {
  name: 'Document',
  props: {
    name: {type: String},
    number: {type: String},
    sum: {type: Number},
    type: {type: String},
    dateCreated: {type: String},
    dateEdit: {type: String},
    provider: {type: Object},
    items: {type: Array},
    id: {type: String},
    confirm: {type: Boolean},
    extFields: {type: Object},
  },

  computed: {
    users () {
      return this.$store.getters.users
    }
  },
  mounted() {
    this.$store.dispatch('getUsers')
  },

  methods: {
    SendTo() {
      const data = {
        id: this.id,
        to: this.to,
      }
      this.$store.dispatch('sendTo', data).then(() => {
        this.to = ''
      })
    },
    Confirm() {
      const data = {
        id: this.id
      }
      this.$store.dispatch('setConfirm', data)
    }
  },

  data: () => ({
    reveal: false,
    to: ''
  }),
}
</script>